import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.util.*;

class Pair implements Comparable<Pair> {
    int first, second;

    public Pair(int first, int second) {
        this.first = first;
        this.second = second;
    }

    public int compareTo(Pair other) {
        return this.first-other.first;
    }
}

public class Antti_buffered {
    public static void main(String[] args) {
        Kattio input = new Kattio(System.in);
        int n = input.getInt();
        int m = input.getInt();
        int k = input.getInt();
        if (k%m != 0 || k/m < 1 || k/m > n) {
            System.out.println("impossible");
            return;
        }
        int t = k/m;
        ArrayList<Pair> a = new ArrayList<>();
        for (int i = 1; i <= n; i++) {
            int x = input.getInt();
            a.add(new Pair(x,i));
        }
        Collections.sort(a);
        int x = n-t-1;
        int y = n-t;
        ArrayList<Integer> r = new ArrayList<>();
        r.add(a.get(y).second);
        y++;
        int c = 1;
        for (int i = 2; i <= n; i++) {
            if (y < n && c*m <= a.get(y).first*(i-1)) {
                c++;
                r.add(a.get(y).second);
                y++;
            } else if (x >= 0 && c*m > a.get(x).first*(i-1)) {
                r.add(a.get(x).second);
                x--;
            } else {
                System.out.println("impossible");
                return;
            }
        }
        for (int i = 0; i < n; i++) {
            System.out.print(r.get(i)+" ");
        }
        System.out.println();
    }
}

/** Simple yet moderately fast I/O routines.
 *
 * Example usage:
 *
 * Kattio io = new Kattio(System.in, System.out);
 *
 * while (io.hasMoreTokens()) {
 *    int n = io.getInt();
 *    double d = io.getDouble();
 *    double ans = d*n;
 *
 *    io.println("Answer: " + ans);
 * }
 *
 * io.close();
 *
 *
 * Some notes:
 *
 * - When done, you should always do io.close() or io.flush() on the
 *   Kattio-instance, otherwise, you may lose output.
 *
 * - The getInt(), getDouble(), and getLong() methods will throw an
 *   exception if there is no more data in the input, so it is generally
 *   a good idea to use hasMoreTokens() to check for end-of-file.
 *
 * @author: Kattis
 */

class Kattio extends PrintWriter {
    public Kattio(InputStream i) {
        super(new BufferedOutputStream(System.out));
        r = new BufferedReader(new InputStreamReader(i));
    }
    public Kattio(InputStream i, OutputStream o) {
        super(new BufferedOutputStream(o));
        r = new BufferedReader(new InputStreamReader(i));
    }

    public boolean hasMoreTokens() {
        return peekToken() != null;
    }

    public int getInt() {
        return Integer.parseInt(nextToken());
    }

    public double getDouble() {
        return Double.parseDouble(nextToken());
    }

    public long getLong() {
        return Long.parseLong(nextToken());
    }

    public String getWord() {
        return nextToken();
    }



    private BufferedReader r;
    private String line;
    private StringTokenizer st;
    private String token;

    private String peekToken() {
        if (token == null)
            try {
                while (st == null || !st.hasMoreTokens()) {
                    line = r.readLine();
                    if (line == null) return null;
                    st = new StringTokenizer(line);
                }
                token = st.nextToken();
            } catch (IOException e) { }
        return token;
    }

    private String nextToken() {
        String ans = peekToken();
        token = null;
        return ans;
    }
}
