import java.util.*;

class Entry implements Comparable<Entry> {
    int count, pos;

    public Entry(int count, int pos) {
        this.count = count;
        this.pos = pos;
    }

    public int compareTo(Entry other) {
        return other.count-this.count;
    }
}

public class Antti {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        int n = input.nextInt();
        ArrayList<Integer>[] graph = new ArrayList[n+1];
        for (int i = 1; i <= n; i++) graph[i] = new ArrayList<Integer>();
        int[][] history = new int[n][2];
        int hi = -1;
        for (int i = 1; i <= n; i++) {
            int rem = input.nextInt();
            int add = input.nextInt();
            while (rem > 0) {
                if (history[hi][1] > 0) {
                    graph[i].add(history[hi][0]);
                    graph[history[hi][0]].add(i);
                }
                if (rem >= history[hi][1]) {
                    rem -= history[hi][1];
                    hi--;
                } else {
                    history[hi][1] -= rem;
                    break;
                }
            }
            hi++;
            history[hi][0] = i;
            history[hi][1] = add;
        }
        int[][] bad = new int[n+1][4];
        int[] count = new int[n+1];
        int[] color = new int[n+1];
        PriorityQueue<Entry> queue = new PriorityQueue<>();
        for (int i = 1; i <= n; i++) {
            queue.add(new Entry(0,i));
        }
        int what = 0;
        while (true) {
            int pos = 0;
            while (!queue.isEmpty()) {
                int newPos = queue.poll().pos;
                if (color[newPos] == 0) {
                    pos = newPos;
                    break;
                }
            }
            if (pos == 0) break;
            for (int i = 1; i <= 4; i++) {
                if (i == 4) {
                    System.out.println("ERROR");
                    System.exit(0);
                }
                if (bad[pos][i] == 0) {
                    color[pos] = i;
                    if (i > what) what = i;
                    for (int adj : graph[pos]) {
                        if (bad[adj][i] == 0) {
                            bad[adj][i] = 1;
                            count[adj]++;
                            queue.add(new Entry(count[adj],adj));
                        }
                    }
                    break;
                }
            }
        }
        System.out.println(what);
        for (int i = 1; i <= n; i++) {
            System.out.print(color[i]+" ");
        }
        System.out.println();
    }
}
