#!/usr/bin/env python3
# Straightforward max-likelihood solution
# Time complexity is O(log_gap(max_infected) * max_queries * log(N))
# But constant factor is bad.
import math
MAX_QUERIES = 50
MIN_INFECTED = 100
MAX_INFECTED = 5000000
GAP = 1.02
N = 10**7

x = [MIN_INFECTED]
while x[-1] < MAX_INFECTED:
    x.append(min(round((x[-1]+1)*GAP), MAX_INFECTED))
nx = len(x)
p = [1.0/nx]*nx

def prob_yes(k):
    return sum(p[i] * pow(1-x[i]/N, k) for i in range(nx))

for _ in range(MAX_QUERIES):
    lo = 0
    hi = N // MIN_INFECTED
    while hi-lo > 1:
        k = (lo+hi)//2
        z = prob_yes(k)
        if z > 0.5: lo = k
        else: hi = k
    k = hi
    print('test', k)
    res = int(input())
    for i in range(nx):
        p[i] *= 1-pow(1-x[i]/N, k) if res else pow(1-x[i]/N, k)
    scale = sum(p)
    for i in range(nx):
        p[i] /= scale
        
print('estimate', max((a, b) for (a, b) in zip(p, x))[1])
